/*
 *	Sherlock Library -- Reading of Config Files
 *
 *	(c) 1997 Martin Mares, <mj@atrey.karlin.mff.cuni.cz>
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "lib.h"

void
cf_read(byte *fn, struct cfitem *cf)
{
  byte buf[1024];
  FILE *f;
  int lino = 0;
  struct cfitem *c;
  byte *msg = NULL;

  if (! (f = fopen(fn, "r")))
    die("Config file `%s' missing", fn);

  while (!msg && fgets(buf, sizeof(buf), f))
    {
      byte *k = strchr(buf, '\n');
      lino++;
      if (!k)
	{
	  msg = "Line too long";
	  break;
	}
      *k = 0;
      if (!buf[0] || buf[0] == '#')
	continue;
      k = buf;
      while (*k && *k != ' ' && *k != '\t')
	k++;
      while (*k == ' ' || *k == '\t')
	*k++ = 0;
      if (!*k)
	{
	  msg = "Missing argument";
	  break;
	}
      for (c = cf; c->type && strcasecmp(c->name, buf); c++)
	;
      switch (c->type)
	{
	case CI_INT:
	  {
	    char *end;
	    *((uns *) c->var) = strtoul(k, &end, 0);
	    if (end && *end)
	      msg = "Invalid number";
	    break;
	  }
	case CI_STRING:
	  *((byte **) c->var) = stralloc(k);
	  break;
	case CI_FUNCTION:
	  msg = ((ci_func) c->var)(c, k);
	  break;
	default:
	  msg = "Unknown keyword";
	}
    }

  if (msg)
    die("%s, line %d: %s", fn, lino, msg);
  fclose(f);
}
