/*
 *	Sherlock Library -- Object Names
 *
 *	(c) 1997 Martin Mares, <mj@atrey.karlin.mff.cuni.cz>
 */

#include <string.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>

#include "lib.h"

void
mk_obj_name(byte *dir, ulg id, byte *buf)
{
  sprintf(buf, "%s/%02x/%06x", dir, id >> 24U, id & 0xffffff);
}

FILE *
create_obj_file(byte *dir, ulg id)
{
  byte buf[32];
  byte *d;
  FILE *f;

  mk_obj_name(dir, id, buf);
  if (f = fopen(buf, "w"))
    return f;
  d = strchr(buf, '/') + 3;
  *d = 0;
  mkdir(buf, 0777);
  *d = '/';
  if (f = fopen(buf, "w"))
    return f;
  die("Unable to create object %s: %m", buf);
}
