/*
 *	Sherlock Search Engine -- Query Processing
 *
 *	(c) 1997 Martin Mares, <mj@atrey.karlin.mff.cuni.cz>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <unistd.h>

#include "sherlock.h"

static int obj_fd, oidx_fd;
static ulg max_oid;

void
show_object(struct query *q, ulg oid)
{
  ulg pos, len;
  uns l;
  ulg *z;

  if (oid >= max_oid)
    {
      add_reply(query_rbuf, "!Invalid object ID %08x", oid);
      return;
    }
  z = (ulg *) read_data(oidx_fd, oid * sizeof(ulg), &l);
  if (l < sizeof(ulg))
    die("Ugly ulg misalign!");
  pos = *z;
  z = (ulg *) read_data(oidx_fd, (oid+1) * sizeof(ulg), &l);
  if (l < sizeof(ulg))
    die("Ugly ulg misalign!");
  len = *z - pos - 1;
  DDBG("Object %08x at %08x, len=%d", oid, pos, len);

  while (len)
    {
      byte *b = read_data(obj_fd, pos, &l);
      if (l > len)
	l = len;
      reply_string(q, b, l);
      pos += l;
      len -= l;
    }
}

void
objects_init(void)
{
  obj_fd = open_file(obj_pool_name);
  oidx_fd = open_file(obj_idx_name);
  max_oid = lseek(oidx_fd, 0, SEEK_END) / sizeof(ulg) - 1;
  log("Found object pool index with 0x%x objects", max_oid);
}
